<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | wkyMlmgUser Plugin for Geeklog 1.4.1                                      |
// +---------------------------------------------------------------------------+
// | admin/index.php                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2008 hiroron  - hiroron AT hiroron DOT com                  |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// |                                                                           |
// | modified by mystral-kk      - geeklog AT mystral-k DOT net                |
// | modified by dengen          - dengen AT mail DOT trybase DOT com          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id$

require_once '../../../lib-common.php';
require_once ('../../auth.inc.php');

// Only let admin users access this page
if ( !SEC_hasRights( 'wkymlmguser.admin' ) ) {
    // Someone is trying to illegally access this page
    COM_errorLog( "Someone has tried to illegally access the wkymlmguser Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR", 1 );
    $display  = COM_siteHeader();
    $display .= COM_startBlock( $LANG_WMMA['access_denied'] );
    $display .= $LANG_WMMA['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter( true );
    echo $display;
    exit;
}

if (!defined('XHTML')) {
    define('XHTML', '');
}

function listwkymlmguser()
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG_WMMA;

    require_once( $_CONF['path_system'] . 'lib-admin.php' );

    $retval = '';

    $header_arr = array(
        array('text' => $LANG_ADMIN['edit'],         'field' => 'edit',    'sort'  => false ),
        array('text' => $LANG_ADMIN['delete'],       'field' => 'delete',  'sort'  => false ),
        array('text' => $LANG_WMMA['stats_email'],   'field' => 'email',   'sort'  => true ),
        array('text' => $LANG_WMMA['stats_regdate'], 'field' => 'regdate', 'sort'  => true ),
    );

    $defsort_arr = array( 'field' => 'email', 'direction' => 'desc' );

    $menu_arr = array (
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=edit',
               'text' => $LANG_ADMIN['create_new'] ),
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=' . $LANG_WMMA['mailform_mode'],
               'text' => $LANG_WMMA['mailform_new'] ),
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=' . $LANG_WMMA['importform_mode'],
               'text' => $LANG_WMMA['importform_new'] ),
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=' . $LANG_WMMA['batchdelete_mode'],
               'text' => $LANG_WMMA['batchdelete_new'] ),
        array( 'url'  => $_CONF['site_admin_url'],
               'text' => $LANG_ADMIN['admin_home'] )
    );

    $text_arr = array(
        'has_menu'     => true,
        'has_extras'   => true,
        'instructions' => $LANG_WMMA['instructions'],
        'icon'         => $_CONF['site_url'] . '/wkymlmguser/images/wkymlmguser.gif',
        'form_url'     => $_CONF['site_admin_url'] . "/plugins/wkymlmguser/index.php"
    );

    $query_arr = array(
        'table'          => 'wkymlmguser',
        'sql'            => "SELECT * FROM {$_TABLES['wkymlmguser']} WHERE 1=1",
        'query_fields'   => array('email','regdate'),
        'default_filter' => COM_getPermSql ('AND')
    );

    if (version_compare(VERSION, '1.5.0') >= 0) {
        $retval .= COM_startBlock($LANG_WMMA['manager'], '', COM_getBlockTemplate('_admin_block', 'header'));
        $retval .= ADMIN_createMenu($menu_arr, $text_arr['instructions'], $text_arr['icon']);
        $retval .= ADMIN_list ('wkymlmguser', 'plugin_getListField_wkymlmguser', $header_arr,
                          $text_arr, $query_arr, $defsort_arr);
        $retval .= COM_endBlock(COM_getBlockTemplate('_admin_block', 'footer'));
    } else {
        $text_arr['title'] = $LANG_WMMA['manager'];
        $retval = ADMIN_list ('wkymlmguser', 'plugin_getListField_wkymlmguser', $header_arr,
                          $text_arr, $query_arr, $menu_arr, $defsort_arr);
    }

    return $retval;
}

function edit_wkymlmguser_page($uid) {
    global $_TABLES, $LANG_WMMA, $_CONF;
    
    if (!empty($uid)) {
        $sql = "SELECT * FROM {$_TABLES['wkymlmguser']} WHERE uid='$uid'";
        $result = DB_query($sql);
        $A = DB_fetchArray($result);
    } else {
        $A['uid'] = 0;
        $A['email'] = isset($_POST['email']) ? $_POST['email'] : '';
    }
    
    $template_path = plugin_templatePath_wkymlmguser('admin');
    $plg_tmpl = new Template($template_path);
    $plg_tmpl->set_file('editor','editor.thtml');
    
    $plg_tmpl->set_var( 'start_block_editor',
        COM_startBlock($LANG_WMMA['manager'], '',
        COM_getBlockTemplate('_admin_block', 'header')) );
    
    $plg_tmpl->set_var( 'site_admin_url', $_CONF['site_admin_url']);
    $plg_tmpl->set_var ( 'xhtml', XHTML );
    $plg_tmpl->set_var( 'mode', $LANG_WMMA['create_from_mode_exec'] );
    $plg_tmpl->set_var( 'title', $LANG_WMMA['create_from_title'] );
    $plg_tmpl->set_var( 'message', $LANG_WMMA['create_from_msg'] );
    $plg_tmpl->set_var( 'label_mail', $LANG_WMMA['create_from_input_mail'] );
    $plg_tmpl->set_var( 'label_remail', $LANG_WMMA['create_from_input_remail'] );
    $plg_tmpl->set_var( 'label_submit', $LANG_WMMA['create_from_input_submit'] );
    
    $plg_tmpl->set_var( 'uid', $A['uid'] );
    $plg_tmpl->set_var( 'email', $A['email'] );
    
    $plg_tmpl->set_var( 'end_block', COM_endBlock(COM_getBlockTemplate('_admin_block','footer')) );
    
    $retval = $plg_tmpl->parse('output','editor');
    
    return $retval;
}

function mail_wkymlmguser_page () {
    global $_CONF, $_TABLES, $_USER, $LANG_WMMA;

    $retval = '';

    $template_path = plugin_templatePath_wkymlmguser('admin');
    $plg_tmpl = new Template($template_path);
    $plg_tmpl->set_file('form','mailform.thtml');
    $plg_tmpl->set_var ('site_url', $_CONF['site_url']);
    $plg_tmpl->set_var ('site_admin_url', $_CONF['site_admin_url']);
    $plg_tmpl->set_var ('layout_url', $_CONF['layout_url']);
    $plg_tmpl->set_var ( 'xhtml', XHTML );
    $plg_tmpl->set_var ('start_block_email', COM_startBlock ($LANG_WMMA['mailform_title'],
            '', COM_getBlockTemplate ('_admin_block', 'header')));
    $plg_tmpl->set_var ('title', $LANG_WMMA['mailform_title']);
    $plg_tmpl->set_var ('lang_from', $LANG_WMMA['mailform_from']);
    $plg_tmpl->set_var ('site_name', $_CONF['site_name']);
    $plg_tmpl->set_var ('lang_replyto', $LANG_WMMA['mailform_replyto']);
    $plg_tmpl->set_var ('site_mail', $_CONF['site_mail']);
    $plg_tmpl->set_var ('lang_subject', $LANG_WMMA['mailform_subject']);
    $plg_tmpl->set_var ('lang_body', $LANG_WMMA['mailform_body']);
    $plg_tmpl->set_var ('lang_options', $LANG_WMMA['mailform_options']);
    $plg_tmpl->set_var ('lang_HTML', $LANG_WMMA['mailform_html']);
    $plg_tmpl->set_var ('lang_urgent', $LANG_WMMA['mailform_urgent']);
    $plg_tmpl->set_var ('lang_send', $LANG_WMMA['mailform_send']);
    $plg_tmpl->set_var ('mode', $LANG_WMMA['mailform_mode_exec']);
    $plg_tmpl->set_var ('end_block', COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer')));

    $plg_tmpl->parse ('output', 'form');
    $retval = $plg_tmpl->finish ($plg_tmpl->get_var ('output'));

    return $retval;
}

function send_message () {
    global $_CONF, $_TABLES, $LANG_WMMA, $_WMMA_CONF;

    $retval = '';

    if (empty ($_POST['fromname']) OR empty ($_POST['replyto']) OR
            empty ($_POST['subject']) OR empty ($_POST['body']) ) {
        $retval .= COM_startBlock ($LANG_WMMA['mailform_title'], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
        $retval .= $LANG_WMMA['mailform_error_input'];
        $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));

        return $retval;
    }

    // Urgent message!
    $priority = (isset ($_POST['priority'])) ? 1 : 0 ;
    
    // If you want to send html mail
    $html = (isset ($_POST['html'])) ? true : false ;
    
    // and now mail it
    $sql = "SELECT * FROM {$_TABLES['wkymlmguser']} WHERE 1=1";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);

    $from = COM_formatEmailAddress ($_POST['fromname'], $_POST['replyto']);
    $subject = COM_stripslashes ($_POST['subject']);
    $message = COM_stripslashes ($_POST['body']);

    // Loop through and send the messages!
    $successes = array ();
    $failures = array ();
    for ($i = 0; $i < $nrows; $i++) {
        $A = DB_fetchArray ($result);
        $to = $A['email'];
        if (!COM_mail ($to, $subject, $message, $from, $html, $priority)) {
            $failures[] = htmlspecialchars ($to);
        } else {
            $successes[] = htmlspecialchars ($to);
        }
    }

    $retval .= COM_startBlock ($LANG_WMMA['mailform_title']);

    $failcount = count ($failures);
    $successcount = count ($successes);
    $mailresult = str_replace ('<successcount>', $successcount, $LANG_WMMA['mailform_msg_mailresult']);
    $retval .= str_replace ('<failcount>', $failcount, $mailresult);
    
    // sending report
    if ($_WMMA_CONF['sending_report_detail_success'] || $_WMMA_CONF['sending_report_detail_failure']) {
        $retval .= $LANG_WMMA['mailform_msg_mailresult_detail'] . $LANG_WMMA['mailform_msg_mailresult_link'];
        // failure
        if ($_WMMA_CONF['sending_report_detail_failure']) {
            $retval .= '<h2>' . $LANG_WMMA['mailform_mail_failure'] . '</h2>';
            for ($i = 0; $i < count ($failures); $i++) {
                $retval .= current ($failures) . '<br>';
                next ($failures);
            }
            if (count ($failures) == 0) {
                $retval .= $LANG_WMMA['mailform_msg_not_failure'];
            }
        }
        // success
        if ($_WMMA_CONF['sending_report_detail_success']) {
            $retval .= '<h2>' . $LANG_WMMA['mailform_mail_success'] . '</h2>';
            for ($i = 0; $i < count ($successes); $i++) {
                $retval .= current ($successes) . '<br>';
                next ($successes);
            }
            if (count ($successes) == 0) {
                $retval .= $LANG_WMMA['mailform_msg_not_success'];
            }
        }
    } else {
        $retval .= $LANG_WMMA['mailform_msg_mailresult_link'];
    }

    $retval .= COM_endBlock ();

    return $retval;
}

function save_wkymlmguser_page ($uid,$mail) {
    global $_TABLES;
    $regdate = strftime ('%Y-%m-%d %H:%M:%S', time ());
    if ($uid > 0) {
        $result = DB_save($_TABLES['wkymlmguser'],'uid,email,regdate', "$uid,'$mail','$regdate'");
    } else {
        $result = DB_save($_TABLES['wkymlmguser'],'email,regdate', "'$mail','$regdate'");
    }
    return $result;
}

function importform_wkymlmguser_page () {
    global $_CONF, $LANG_WMMA;

    $retval = '';
    
    $retval .= COM_startBlock ($LANG_WMMA['importform_title'], ''
                    ,COM_getBlockTemplate ('_admin_block', 'header'));
    $retval .= $LANG_WMMA['importform_message'] . '<br' . XHTML . '></br' . XHTML . '>';
    $retval .= "<form action=\"{$_CONF['site_admin_url']}/plugins/wkymlmguser/index.php\" method=\"post\" enctype=\"multipart/form-data\">" . LB;
    $retval .= $LANG_WMMA['importform_file'] . "<input type=\"file\" name=\"importfile\" size=\"40\"" . XHTML . ">";
    $retval .= "<input type=\"hidden\" name=\"mode\" value=\"{$LANG_WMMA['importform_mode_exec']}\"" . XHTML . ">";
    $retval .= "<input type=\"submit\" name=\"submit\" value=\"{$LANG_WMMA['importform_submit']}\"" . XHTML . ">";
    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));
    
    return $retval;
}

function importusers ($file)
{
    global $_CONF, $_TABLES, $LANG_WMMA, $_WMMA_CONF;

    // Setting this to true will cause import to print processing status to
    // webpage and to the error.log file
    
    $verbose_import_success = $_WMMA_CONF['verbose_import_disp_success'];
    $verbose_import_failure = $_WMMA_CONF['verbose_import_disp_failure'];
    $verbose_import_log_success = $_WMMA_CONF['verbose_import_log_success'];
    $verbose_import_log_failure = $_WMMA_CONF['verbose_import_log_failure'];

    $retval = '';

    // Bulk import implies admin authorisation:
    $_CONF['usersubmission'] = 0;

    // First, upload the file
    require_once ($_CONF['path_system'] . 'classes/upload.class.php');

    $upload = new upload ();
    $upload->setPath ($_CONF['path_data']);
    $upload->setAllowedMimeTypes (array ('text/plain' => '.txt'));
    $upload->setFileNames ('wkymlmguser_importfile.txt');
    if ($upload->uploadFiles ()) {
        // Good, file got uploaded, now install everything
        $thefile =  current ($_FILES);
        $filename = $_CONF['path_data'] . 'wkymlmguser_importfile.txt';
    } else {
        // A problem occurred, print debug information
        $retval .= COM_startBlock ($LANG_WMMA['importform_title'], '',
                        COM_getBlockTemplate ('_msg_block', 'header'));
        $retval .= $upload->printErrors ();
        $retval .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        return $retval;
    }

    $users = file ($filename);

    $retval .= COM_startBlock ($LANG_WMMA['importform_user'], '',
            COM_getBlockTemplate ('_admin_block', 'header'));

    // Following variables track import processing statistics
    $successes = 0;
    $failures = 0;
    foreach ($users as $line) {
        $line = rtrim ($line);
        if (empty ($line)) {
            continue;
        }

        list ($email) = explode ("\t", $line);

        $email = COM_applyFilter ($email);

        // prepare for database
        $emailAddr = trim ($email);

        if (COM_isEmail ($email)) {
            // email is valid form
            $ecount = DB_count ($_TABLES['wkymlmguser'], 'email',
                                addslashes ($emailAddr));
COM_errorLog("count: $ecount, mail: $emailAddr",1);
            if ($ecount == 0) {
                // user doesn't already exist
                $regdate = strftime ('%Y-%m-%d %H:%M:%S', time ());
                DB_save($_TABLES['wkymlmguser'],'email,regdate', "'$emailAddr','$regdate'");

                if ($verbose_import_success) {
                    $retval .= "<br> Account for <b>$emailAddr</b> created successfully.<br>\n";
                }
                if ($verbose_import_log_success) {
                    COM_errorLog("Account for $emailAddr created successfully",1);
                }
                $successes++;
            } else {
                if ($verbose_import_failure) {
                    $retval .= "<br><b>$email</b> already exists, account not created.<br>\n"; // user already exists
                }
                if ($verbose_import_log_failure) {
                    COM_errorLog("$email: email already exists, account not created",1);
                }
                $failures++;
            } // end if ecount == 0
        } else {
            if ($verbose_import_failure) {
                $retval .= "<br><b>$email</b> is not a valid email address, account not created<br>\n"; // malformed email
            }
            if ($verbose_import_log_failure) {
                COM_errorLog("$email is not a valid email address, account not created",1);
            }
            $failures++;
        } // end if COM_isEmail($email)
    } // end foreach

    unlink ($filename);

    $retval .= '<p>' . sprintf ($LANG_WMMA['importform_result'], $successes, $failures) . '</p>';

    $retval .= COM_endBlock (COM_getBlockTemplate ('_admin_block', 'footer'));

    return $retval;
}

function batchdelete()
{
    global $_CONF, $_TABLES, $LANG_ADMIN, $LANG01, $LANG_WMMA;

    $display = '';

    require_once( $_CONF['path_system'] . 'lib-admin.php' );

    $usr_type = '';
    if (isset($_REQUEST['usr_type'])) {
        $usr_type = COM_applyFilter($_REQUEST['usr_type']);
    } else {
        $usr_type = 'recent';
    }
    $usr_time_arr = array();
    $usr_time = '';
    if (isset($_REQUEST['usr_time'])) {
        $usr_time_arr = $_REQUEST['usr_time'];
    } else {
        $usr_time_arr['old'] = 24;
        $usr_time_arr['recent'] = 1;
    }
    $usr_time = $usr_time_arr[$usr_type];

    // list of options for user display
    // sel => form-id
    // desc => title
    // txt1 => text before input-field
    // txt2 => text after input field
    $opt_arr = array(
        array('sel' => 'old', 'desc' => $LANG_WMMA['batchdelete_old_desc'], 'txt1' => $LANG_WMMA['batchdelete_old_txt1'], 'txt2' => $LANG_WMMA['batchdelete_old_txt2']),
        array('sel' => 'recent', 'desc' => $LANG_WMMA['batchdelete_recent_desc'], 'txt1' => $LANG_WMMA['batchdelete_recent_txt1'], 'txt2' => $LANG_WMMA['batchdelete_recent_txt2'])
    );

    $template_path = plugin_templatePath_wkymlmguser('admin');
    $user_templates = new Template($template_path);
    $user_templates->set_file (array ('form' => 'batchdelete.thtml',
                                      'options' => 'batchdelete_options.thtml'));
    $user_templates->set_var ('site_admin_url', $_CONF['site_admin_url']);
    $user_templates->set_var ('mode', $LANG_WMMA['batchdelete_mode']);
    $user_templates->set_var ('usr_type', $usr_type);
    $user_templates->set_var ('usr_time', $usr_time);
    $user_templates->set_var ('lang_instruction', $LANG_WMMA['batchdelete_instruction']);
    $user_templates->set_var ('lang_updatelist', $LANG_WMMA['batchdelete_updatelist']);

    for ($i = 0; $i < count ($opt_arr); $i++) {
        $selector = '';
        if ($usr_type == $opt_arr[$i]['sel']) {
            $selector = ' checked="checked"';
        }
        $user_templates->set_var ('sel_id', $opt_arr[$i]['sel']);
        $user_templates->set_var ('selector', $selector);
        $user_templates->set_var ('lang_description', $opt_arr[$i]['desc']);
        $user_templates->set_var ('lang_text_start', $opt_arr[$i]['txt1']);
        $user_templates->set_var ('lang_text_end', $opt_arr[$i]['txt2']);
        $user_templates->set_var ('id_value', $usr_time_arr[$opt_arr[$i]['sel']]);
        $user_templates->parse('options_list', 'options', true);
    }
    $user_templates->parse('form', 'form');
    $desc = $user_templates->finish($user_templates->get_var('form'));

    $header_arr = array(
        array('text' => $LANG_WMMA['stats_uid'],   'field' => 'uid',   'sort'  => true ),
        array('text' => $LANG_WMMA['stats_email'],   'field' => 'email',   'sort'  => true ),
    );

    switch ($usr_type) {
        case 'old':
            $header_arr[] = array('text' => $LANG_WMMA['stats_regdate'], 'field' => 'regdate', 'sort' => true);
            $list_sql = "";
            $filter_sql = "(UNIX_TIMESTAMP() - UNIX_TIMESTAMP(regdate)) > " . ($usr_time * 2592000);
            $sort = 'regdate';
            break;
        case 'recent':
            $header_arr[] = array('text' => $LANG_WMMA['stats_regdate'], 'field' => 'regdate', 'sort' => true);
            $list_sql = "";
            $filter_sql = "(UNIX_TIMESTAMP() - UNIX_TIMESTAMP(regdate)) < " . ($usr_time * 2592000);
            $sort = 'regdate';
            break;
    }

    $menu_arr = array (
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php',
               'text' => $LANG_WMMA['manager'] ),
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=' . $LANG_WMMA['mailform_mode'],
               'text' => $LANG_WMMA['mailform_new'] ),
        array( 'url'  => $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php?mode=' . $LANG_WMMA['importform_mode'],
               'text' => $LANG_WMMA['importform_new'] ),
        array( 'url'  => $_CONF['site_admin_url'],
               'text' => $LANG_ADMIN['admin_home'] )
    );

    $text_arr = array('has_menu'     => true,
                      'has_extras'   => true,
                      'title'        => $LANG_WMMA['batchdelete_new'],
                      'instructions' => "$desc",
                      'icon'         => $_CONF['site_url'] . '/wkymlmguser/images/wkymlmguser.gif',
                      'form_url'     => $_CONF['site_admin_url'] . "/plugins/wkymlmguser/index.php?mode=batchdelete&amp;usr_type=$usr_type&amp;usr_time=$usr_time",
                      'help_url'     => ''
    );

    $defsort_arr = array( 'field' => $sort, 'direction' => 'ASC' );

    $sql = "SELECT * FROM {$_TABLES['wkymlmguser']} WHERE 1=1";

    $query_arr = array (
        'table' => 'wkymlmguser',
        'sql' => $sql,
        'query_fields' => array('email','regdate'),
        'default_filter' => "AND $filter_sql "
    );
    $listoptions = array('chkdelete' => true, 'chkfield' => 'uid');

    // eǗŏF/폜̖BubNǗ̐擪̗L/̖ Ή 2007/05/01 hiro {
    $text_arr['form_start'] = "<form action=\"{$text_arr['form_url']}\" method=\"post\" id=\"admin-list\" class=\"basic\">";
    $text_arr['form_end'] = "<input type=\"hidden\" name=\"mode\" value=\"{$LANG_WMMA['batchdelete_mode_exec']}\">".LB."</form>";
    // } eǗŏF/폜̖BubNǗ̐擪̗L/̖ Ή 2007/05/01 hiro
    if (version_compare(VERSION, '1.5.0') >= 0) {
        $display .= COM_startBlock($LANG_WMMA['batchdelete_new'], '', COM_getBlockTemplate('_admin_block', 'header'));
        $display .= ADMIN_createMenu($menu_arr, $text_arr['instructions'], $text_arr['icon']);
        $display .= ADMIN_list ("wkymlmguser", "plugin_getListField_wkymlmguser", $header_arr, $text_arr,
            $query_arr, $defsort_arr, '', '', $listoptions);
        $display .= COM_endBlock(COM_getBlockTemplate('_admin_block', 'footer'));
    } else {
        $text_arr['title'] = $LANG_WMMA['batchdelete_new'];
        $display .= ADMIN_list ("wkymlmguser", "plugin_getListField_wkymlmguser", $header_arr, $text_arr,
            $query_arr, $menu_arr, $defsort_arr, '', '', $listoptions);
    }

    // eǗŏF/폜̖BubNǗ̐擪̗L/̖ Ή 2007/05/01 hiro {
    //$display .= "<input type=\"hidden\" name=\"mode\" value=\"batchdeleteexec\"></form>" . LB;
    // } eǗŏF/폜̖BubNǗ̐擪̗L/̖ Ή 2007/05/01 hiro
    return $display;
//

}

function batchdeleteexec()
{
    global $_CONF, $_TABLES, $LANG_WMMA;
    $msg = '';
    $user_list = array();
    if (isset($_POST['delitem'])) {
        $user_list = $_POST['delitem'];
    }

    if (count($user_list) == 0) {
        $msg = $LANG_WMMA['batchdelete_msg_not_select'] . "<br>";
    }
    $c = 0;

    if (isset($_POST['delitem']) AND is_array($_POST['delitem'])) {
        foreach($_POST['delitem'] as $delitem) {
            $delitem = COM_applyFilter($delitem);
            DB_delete ($_TABLES['wkymlmguser'], 'uid', $delitem);
            $ecount = DB_count ($_TABLES['wkymlmguser'], 'uid', $delitem);
            if ($ecount > 0) {
                $msg .= "<strong>{$LANG_WMMA['stats_uid']} $delitem {$LANG_WMMA['batchdelete_msg_not_delete']}</strong><br>\n";
            } else {
                $c++; // count the deleted users
            }
        }
    }

    // Since this function is used for deletion only, its necessary to say that
    // zero where deleted instead of just leaving this message away.
    COM_numberFormat($c); // just in case we have more than 999)..
    $msg .= "{$LANG_WMMA['batchdelete_msg_delete']}: $c<br>\n";
    return $msg;
}

// MAIN

$display = '';

$mode = '';
if (isset ($_REQUEST['mode'])) {
    $mode = COM_applyFilter($_REQUEST['mode']);
}
$uid = '';
if (isset ($_REQUEST['uid'])) {
    $uid = COM_applyFilter($_REQUEST['uid'],true);
}

if ($mode == 'edit') {

    $display .= COM_siteHeader ('menu', 'Editor');
    $display .= edit_wkymlmguser_page($uid);

} elseif ($mode == $LANG_WMMA['mailform_mode']) {

    $display .= COM_siteHeader ('menu', 'Editor');
    $display .= mail_wkymlmguser_page();

} elseif ($mode == $LANG_WMMA['mailform_mode_exec']) {

    $display .= COM_siteHeader ('menu', $LANG_WMMA['manager']);
    $display .= send_message();

} elseif ($mode == $LANG_WMMA['importform_mode']) {

    $display .= COM_siteHeader ('menu', $LANG_WMMA['manager']);
    $display .= importform_wkymlmguser_page();

} elseif ($mode == $LANG_WMMA['importform_mode_exec']) {

    $display .= COM_siteHeader ('menu', $LANG_WMMA['manager']);
    $display .= importusers ($_POST['file']);

} elseif ($mode == $LANG_WMMA['batchdelete_mode'] || $mode == $LANG_WMMA['batchdelete_mode_exec']) {
    $msg = '';
    if ($mode == $LANG_WMMA['batchdelete_mode_exec']) { $msg = batchdeleteexec(); }
    $display .= COM_siteHeader ('menu', $LANG_WMMA['batchdelete_new']);
    if ($mode == $LANG_WMMA['batchdelete_mode_exec']) {
        $timestamp = strftime( $_CONF['daytime'] );
        $display .= COM_startBlock( $MESSAGE[40] . ' - ' . $timestamp, '',
                               COM_getBlockTemplate( '_msg_block', 'header' ))
                . '<p style="padding:5px"><img src="' . $_CONF['layout_url']
                . '/images/sysmessage.' . $_IMAGE_TYPE . '" border="0" align="left"'
                . ' alt="" style="padding-right:5px; padding-bottom:3px"' . XHTML .'>'
                . $msg . '</p>'
                . COM_endBlock( COM_getBlockTemplate( '_msg_block', 'footer' ));
    }
    $display .= batchdelete();

} else { // 'cancel' or no mode at all

    if ($mode == $LANG_WMMA['create_from_mode_exec']) {
        $result = save_wkymlmguser_page($uid, COM_applyFilter($_POST['email']));
    } elseif ($mode == $LANG_WMMA['delete_from_mode_exec']) {
        $result = DB_delete($_TABLES['wkymlmguser'],'uid', "$uid");
    }

    $display .= COM_siteHeader ('menu', $LANG_WMMA['manager']);
    $display .= listwkymlmguser();
    
}

$display .= COM_siteFooter ();

echo $display;

?>