<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | wkyMlmgUser Plugin 1.2                                                    |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2008-2012 hiroron  - hiroron AT hiroron DOT com             |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// |                                                                           |
// | modified by mystral-kk      - geeklog AT mystral-k DOT net                |
// | modified by dengen          - dengen AT mail DOT trybase DOT com          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id$

/**
* This is the generic functions.inc for the Universal Plugin Toolkit for Geeklog.
* You need to change all instances of wkymlmguser with the name of your plugin.
*/

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die ('This file can not be used on its own.');
}

$plugin_path = $_CONF['path'] . 'plugins/wkymlmguser/';

/**
* Language file Include
*/

$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';
if ( file_exists( $langfile ) ) {
    include_once $langfile;
} else {
    include_once $plugin_path . 'language/english_utf-8.php';
}

/**
* Check and see if we need to load the plugin configuration
*/
if ( !isset($_WMMA_CONF['wkymlmguserloginrequired'])) {
    require_once $_CONF['path_system'] . 'classes/config.class.php';
    
    $wmma_config = config::get_instance();
    $_WMMA_CONF = $wmma_config->get_config('wkymlmguser');
}

/**
 * wkymlmguser plugin table(s)
 */
$_TABLES['wkymlmguser']  = $_DB_table_prefix . 'wkymlmguser';	


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* @return    array   Associative array of menu items to be added to menu
*
*/

function plugin_getmenuitems_wkymlmguser ()
{
    global $_CONF, $_USER, $_WMMA_CONF, $LANG_WMMA;

    $anon = (empty ($_USER['uid']) || ($_USER['uid'] <= 1)) ? true : false;
    if (($_WMMA_CONF['hidewkymlmgusermenu'] == 1) || ($anon &&
            ($_CONF['loginrequired'] || $_WMMA_CONF['wkymlmguserloginrequired']))) {
        return false;
    }

    $menuitems[ $LANG_WMMA['menu_title'] ] = $_CONF['site_url'] . '/wkymlmguser/index.php';

    return $menuitems;
}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/

function plugin_commentsupport_wkymlmguser ()
{
    return false;
}


/**
* This will put an option for wkymlmguser in the command and control block on
* moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/

function plugin_cclabel_wkymlmguser ()
{
    global $_CONF, $LANG_WMMA;

    if (SEC_hasRights ('wkymlmguser.admin')) {
        return array ($LANG_WMMA['display_name'],
                      $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php',
                      plugin_geticon_wkymlmguser ());
    }

    return false;
}

/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/

function plugin_geticon_wkymlmguser ()
{
    global $_CONF;

    return $_CONF['site_url'] . '/wkymlmguser/images/wkymlmguser.gif';
}

/**
* returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify use it
*
* @return   mixed   array(title, url, num. items), or void when not allowed
*
*/

function plugin_getadminoption_wkymlmguser ()
{
    global $_CONF, $_TABLES, $LANG_WMMA;

//  if ( SEC_hasRights( 'wkymlmguser.admin,wkymlmguser.edit', 'OR' ) ) {
    if ( SEC_hasRights( 'wkymlmguser.admin', 'OR' ) ) {
        $pi_name   = $LANG_WMMA['display_name'];
        $admin_url = $_CONF['site_admin_url'] . '/plugins/wkymlmguser/index.php';
        $num_items = '';
        $num_items = DB_count( $_TABLES['wkymlmguser'] );
        return array ( $pi_name, $admin_url, $num_items );
    }
}

/**
* Called by the plugin Editor to display the current plugin code version
* This may be different than the version installed and registered currently.
* If newer then you may want to run the update
*
* @return   string  version number
*
*/

function plugin_chkVersion_wkymlmguser () 
{
    global $_CONF;

    require_once $_CONF['path'] . 'plugins/wkymlmguser/autoinstall.php';          

    $inst_parms = plugin_autoinstall_wkymlmguser('wkymlmguser'); 

    return $inst_parms['info']['pi_version'];
}

/**
* Returns the user option for this plugin
*
* Adds the plugin to the user menu
*
* Universal Plugin:  modify/uncomment use it
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/

function plugin_getuseroption_wkymlmguser ()
{
//    global $_CONF;

//    if ( SEC_hasRights( 'wkymlmguser.edit,wkymlmguser.view','OR' ) ) {
//        $pi_name = ucfirst( "wkymlmguser" );
//        $url     = $_CONF['site_url'] . '/wkymlmguser/index.php';
//        return array ( $pi_name, $url, 0 );
//    }
}

/**
* Upgrade the wkymlmguser plugin
*
* @return   int     Number of message to display (true = generic success msg)
*
*/

function plugin_upgrade_wkymlmguser ()
{
    global $_CONF, $_TABLES, $_WMMA_CONF;

    $installed_version = DB_getItem($_TABLES['plugins'], 'pi_version',
                                    "pi_name = 'wkymlmguser'");
    $code_version = plugin_chkVersion_wkymlmguser();
    if ($installed_version == $code_version) {
        // nothing to do
        return true;
    }

    require_once $_CONF['path'] . 'plugins/wkymlmguser/autoinstall.php';

    if (! plugin_compatible_with_this_version_wkymlmguser('wkymlmguser')) {
        return 3002;
    }

    $inst_parms = plugin_autoinstall_wkymlmguser('wkymlmguser');
    $pi_gl_version = $inst_parms['info']['pi_gl_version'];

    $current_version = $installed_version;
    $done = false;
    $current_config = false;
    while (! $done) {
        switch ($current_version) {
        case '1.1.0':
            // no db changes
            $current_version = '1.1.1';
            break;
        case '1.1.1':
            require_once $_CONF['path_system'] . 'classes/config.class.php';

            $plugin_path = $_CONF['path'] . 'plugins/wkymlmguser/';
            require_once $plugin_path . 'install_defaults.php';

            if (file_exists($plugin_path . 'config.php')) {
                global $_DB_table_prefix, $_WMMA_CONF;

                require_once $plugin_path . 'config.php';
            }

            if (!plugin_initconfig_wkymlmguser()) {
                echo 'There was an error upgrading the wkymlmguser plugin';
                return false;
            }

            $wmma_config = config::get_instance();
            $_WMMA_CONF = $wmma_config->get_config('wkymlmguser');

            $current_config = true;

            $current_version = '1.2.0';
            break;
        default:
            $done = true;
        }
    }

    // update the version numbers
    DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '{$code_version}', pi_gl_version = '{$pi_gl_version}' WHERE pi_name = 'wkymlmguser'");

    return true;
}


function plugin_getListField_wkymlmguser ($fieldname, $fieldvalue, $A, $icon_arr)
{
    global $_CONF, $MESSAGE, $LANG_WMMA;

    $retval = '';

    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                             $A['perm_owner'], $A['perm_group'],
                             $A['perm_members'], $A['perm_anon']);
    if ($access > 0) {
        switch($fieldname) {
            case 'edit':
                if ($access == 3) { // User is in Root group
                    $retval = "<a href=\"{$_CONF['site_admin_url']}/plugins/wkymlmguser/index.php"
                            . "?mode=edit&amp;uid={$A['uid']}\">{$icon_arr['edit']}</a>";
                }
                break;
            case 'delete':
                if ($access == 3) { // User is in Root group
                    $iconimg = "<img src=\"{$_CONF['site_url']}/wkymlmguser/images/delete.png\" border=\"0\" alt=\"{$LANG_ADMIN['delete']}\" title=\"{$LANG_ADMIN['delete']}\">";
                    $retval = "<a href=\"{$_CONF['site_admin_url']}/plugins/wkymlmguser/index.php"
                            . "?mode={$LANG_WMMA['delete_from_mode_exec']}&amp;uid={$A['uid']}\" onclick=\"return confirm('{$MESSAGE[76]}');\">$iconimg</a>";
                }
                break;
            default:
                $retval = $fieldvalue;
                break;
        }
    } else {
        $retval = false;
    }

    return $retval;
}


/**
* Automatic uninstall function for plugins
*
* @return   array
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
*/
function plugin_autouninstall_wkymlmguser ()
{
    $out = array (
        /* give the name of the tables, without $_TABLES[] */
        'tables' => array('wkymlmguser'),
        /* give the full name of the group, as in the db */
        'groups' => array('メルマガユーザ Admin'),
        /* give the full name of the feature, as in the db */
        'features' => array('wkymlmguser.admin'),
        /* give the full name of the block, including 'phpblock_', etc */
        'php_blocks' => array(),
        /* give all vars with their name */
        'vars'=> array()
    );
    return $out;
}


function plugin_templatePath_wkymlmguser ($subpath = '')
{
    global $_CONF, $LANG_WMMA;
    $pi_name  = $LANG_WMMA['pi_name'];
    
    $layout_path = $_CONF['path_layout'] . $pi_name;
    $layout_path .= empty($subpath) ? '' : '/' . $subpath;
    
    if ( is_dir($layout_path) ) {
        $retval = $layout_path;
    } else {
        $retval = $_CONF['path'] . 'plugins/' . $pi_name . '/templates';
        $retval .= empty($subpath) ? '' : '/' . $subpath;
    }
    return $retval;
}

function plugin_getheadercode_wkymlmguser ()
{
    global $_CONF;
    if ( file_exists( $_CONF['path_layout'] . 'wkymlmguser/style.css' ) ) {
        $css = $_CONF['layout_url'] . '/wkymlmguser/style.css';
    } else {
        $css = $_CONF['site_admin_url'] . '/plugins/wkymlmguser/style.css';
    }
    return "<link rel=\"stylesheet\" type=\"text/css\" href=\"{$css}\">" . LB;
}

function plugin_captcha_label_wkymlmguser ()
{
    global $LANG_WMMA;
    return $LANG_WMMA['display_name'];
}

?>